<?php
/**
 * SampleController.php
 * SampleController controller.
 * @version    160901:1
 * @author     karminski karminski@outlook.com>
 * 
 * @changes    
 *             160901:1 INIT version.
 */

/**
 * class SampleController extends BaseController 
 */
class SampleController extends SaltFish\BaseController{

    private $_h;
    public  $input                 = array(); // user input data

    public  $default_input_method  = '';
    public  $output_format         = '';
    public  $input_param           = array();


    /**
     * [__construct description]
     */
    public function __construct(){
        parent::__construct();
    }

    /**
     * public function setInputRules
     */
    public function setInputRules(){
        $this->default_input_method  = SaltFish\Input::METHOD_GET;
        $this->output_format         = SaltFish\Feedback::FORMAT_JSON;
        $this->input_param           = array(
            array(
                'param'     => 'uid',
                'condition' => array(
                    'method'    => null,
                    'type'      => SaltFish\Input::TYPE_INT,
                    'limit'     => array(),
                    'default'   => 0,
                    'necessary' => true,
                ),
            ),
        );
        SaltFish\Feedback::setOutputFormat($this->output_format);
        SaltFish\Feedback::setCallback(null);
    }

    /**
     * [initDatabase description]
     * @return [type] [description]
     */
    public function initDatabase(){
        $this->SampleCache          = new SampleCache;
        $this->SampleMongoDBStorage = new SampleMongoDBStorage;
        $this->SampleMySQLStorage   = new SampleMySQLStorage;
    }

    /**
     * [run description]
     * @return [type] [description]
     */
    public function run(){
        // init 
        $Log = $this->_log;

        // get user input
        $exception = array();
        $this->setInputRules();
        if(!SaltFish\Input::get($this->default_input_method, $this->input_param, $this->input, $exception)){
            $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_WRONG_INPUT, $exception, array()); 
            BaseView::renderJson($feed);
            return false;
        }

        // init request, result
        $SampleRequest = new SampleRequest($this->input);
        $SampleResult = new SampleResult;

        // check access token
//        if(SaltFish\AccessibilityCheck::isIllegalToken($SampleRequest)){
//            $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_WRONG_INPUT, FeedbackInfo::M_ILLEGAL_TOKEN, array());
//            BaseView::renderJson($feed);
//            return false;
//        }

        // init database
        $this->initDatabase();

        // sample 1 : get data from cache
        if(!$this->SampleCache->get($SampleRequest, $SampleResult)){
            $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_NO_RESULT, FeedbackInfo::M_NO_RESULT, array());
            BaseView::renderJson($feed);
            return false;
        }
        
        // ok, feedback
        $feedData = array();
        $SampleResult->exportForFeedback($feedData);
        $feed = SaltFish\Feedback::getFeed(FeedbackInfo::S_OK, FeedbackInfo::M_OK, $feedData);
        BaseView::renderJson($feed);
        return true;
    }
}
    
