<?php
/**
*   SampleApiProxy.php
*   Sample api proxy.
*   @version    161011:2
*   @author     karminski <code.karminski@outlook.com>
*/

/**
 * class LeancloudRestApiProxy
 */
class SampleApiProxy extends ApiProxy{

    const API_SRC                     = 'sample_repo';
    const API_PUBLIC_KEY              = 'UPbGdCjQyrYgX8tn34Zl';

    const REQUEST_TIMEOUT             = 5; // seconds

    const API_HOST                    = 'sample-api.juejin.im';

    public static $GET_SAMPLE_API = array(
        ENV_PRODUCT => 'http://192.168.0.1:8000/v1/get?id=%s&token=%s&src=%s',
        ENV_BETA    => 'http://192.168.0.2:8000/v1/get?id=%s&token=%s&src=%s',
        ENV_TEST    => 'http://192.168.0.3:8000/v1/get?id=%s&token=%s&src=%s', 
    );

    /**
     * [get description]
     * @param  SampleRequest $SampleRequest [description]
     * @param  SampleResult  $SampleResult  [description]
     * @return [type]                       [description]
     */
    public static function get(SampleRequest $SampleRequest, SampleResult $SampleResult){
        $requestData = array(
            'ids' => array()
        );
        $SampleRequest->exportAllIds($requestData['ids']);
        $requestData['token'] = self::generateToken($requestData, self::API_PUBLIC_KEY);
        $requestData['src']   = self::API_SRC;
        $query = array(
            'url'       => sprintf(self::$GET_SAMPLE_API[SERVER_ENV], implode("|", $requestData['entryIds']), $requestData['token'], $requestData['src']),
            'host'      => self::API_HOST,
            'timeout'   => self::REQUEST_TIMEOUT,
            'urlencode' => false,
        );
        $result = SaltFish\Curl::httpRequest($query);
        return $SampleResult->setByApiProxy($result);
    }

}
