<?php
/**
*   SampleMongoDBStorage.php
*   Sample MongoDB storage model.
*   @version    170410:1
*   @author     karminski <code.karminski@outlook.com>
*/

/**
 * class SampleMongoDBStorage
 */
class SampleMongoDBStorage{

    const CONNECTION_INFO = 'SampleMongoDBStorage';
    const STORAGE_ADDRESS = 'SampleMongoDBStorage.Sample';

    public $MongoDB;

    /**
     * [__construct description]
     * @param [type] $redis [description]
     */
    public function __construct(){
        $this->MongoDB = SaltFish\MongoDBFactory::spawn(self::CONNECTION_INFO);
    }


    /**
     * [get description]
     * @param  SampleRequest $SampleRequest [description]
     * @param  SampleResult  $SampleResult  [description]
     * @return [type]                       [description]
     */
    public function get(SampleRequest $SampleRequest, SampleResult $SampleResult){
        $req = array();
        if(!$SampleRequest->exportForSampleMongoDBStorageGet($req)) return false;
        if($SampleRequest->isAfterRequest()){
            $filter = array(
                "createdAt" => array(
                    '$gt' => $req['after'],
                ),
            );
        }else{
            $filter = array(
                "createdAt" => array(
                    '$lt' => $req['before'],
                ),
            );
        }
        $options = array(
            'sort'  => array("createdAt" => 1),
            'limit' => SampleRequest::PAGE_LIMIT,
        );
        $query = new MongoDB\Driver\Query($filter, $options);
        try{
            $r = $this->MongoDB->executeQuery(self::STORAGE_ADDRESS, $query);
        }
        catch(MongoDB\Driver\Exception\BulkWriteException $e){
            return false;
        }
        if(!is_object($r)) return false;
        foreach($r as $doc){
            if(empty($doc)) continue;
            if(!$SampleResult->importFromSampleMongoDBStorageGet($doc)) return false;
        }
        return true;
    }

    /**
     * [set description]
     * @param SampleRequest $SampleRequest [description]
     */
    public function set(SampleRequest $SampleRequest){
        $data = array();
        if(!$EntryStorageRequest->exportForSampleMongoDBStorageSet($data)) return false;
        $bulk = new MongoDB\Driver\BulkWrite();
        $result_obj = (array) ($bulk->insert($data));
        try{
            $r = $this->MongoDBManager->executeBulkWrite(self::STORAGE_ADDRESS, $bulk);
        }catch(MongoDB\Driver\Exception\BulkWriteException $e){
            return false;
        }
        if (! is_object($r)){
            return false;
        }
        return true;
    }
    
}